<!--
Andriy Andrusevych
IT Generation
Доопрацювання практичної роботи (видалення повторів з історії + клік на історії)

-->

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
  <style>
    * {
      margin: 0;
      padding: 0;
    }

    body {
      padding: 0 20px;
    }

    .header,
    .header__which,
    .header__info {
      display: flex;
      background-color: beige;
      justify-content: center;
    }

    .container {
      max-width: 1400px;
      margin: 0 auto;
    }

    .cards {
      display: grid;
      grid-template-columns: 1fr 1fr;
    }

    .card-item {
      background-color: aquamarine;
      display: flex;
      align-items: center;
      flex-direction: column;
    }

    .cards>div,
    .cards>ul {
      border: 2px solid whitesmoke;
      height: 300px;
    }

    div,
    ul {
      font-size: 30px;
    }

    ul {
      list-style-type: none;
      display: grid;
      grid-template-columns: 1fr 1fr;
    }

    li {
      width: 40px;
      background-color: lightblue;
      border: 2px solid whitesmoke;
    }
  </style>
</head>

<body>
  <div class="container">
    <header>
      <div class="header">JavaScript Key Code <span class="header__code"></span></div>
      <div class="header__which"></div>
      <div class="header__info">Key Code Information</div>
    </header>
    <main>
      <div class="cards">
        <div class="card-item">
          <h4>event.key</h4>
          <div class="key"></div>
        </div>
        <div class="card-item">
          <h4>event.code</h4>
          <div class="code"></div>
        </div>
        <div class="card-item">
          <h4>event.which</h4>
          <div class="which"></div>
        </div>
        <div class="card-item">
          <h4>History</h4>
          <ul class="historyBlock"></ul>
        </div>
      </div>
    </main>
  </div>


  <script>
    const key = document.querySelector(".key"),
      code = document.querySelector(".code"),
      which = document.querySelector(".which"),
      historyBlock = document.querySelector(".historyBlock"),
      headerCode = document.querySelector(".header__code"),
      headerWhich = document.querySelector(".header__which");


let events=[];//масив подій

    window.addEventListener("keyup", (event) => {
      key.innerHTML = event.key;
      code.innerHTML = event.code;
      which.innerHTML = event.which;
      addLetterHistory();
      headerCode.innerHTML = event.which;
      headerWhich.innerHTML = event.which;
      events.push(event);

    });

    function simulate() { //функція для симуляції натискання кнопки
      events.forEach(el =>{
        if(el.key.toUpperCase()==this.innerHTML){
          window.dispatchEvent(el);
        }
      });
    };

    let array = [];
    function addLetterHistory() {
      let temp;
      for (let i = 0; i < array.length; i++) {
        if (event.key.toUpperCase() === array[i]) {
          temp = array.splice(i, 1);
          historyBlock.innerHTML = "";
          array.forEach(el => {
            let li = document.createElement('li');
            li.innerHTML = el;
            historyBlock.insertAdjacentElement("afterbegin", li);
            li.addEventListener('click', simulate);
            return 1;
          });
        };

      };
      let current = event.key.toUpperCase();
      array.unshift(current);
      let li = document.createElement('li');
      li.innerHTML = array[0];
      historyBlock.insertAdjacentElement("afterbegin", li);
      if (array.length > 4) {
        array = array.slice(0, 4);
        historyBlock.lastElementChild.remove();
      }
      li.addEventListener('click', simulate);
    };


  </script>
</body>

</html>